<?

// $Id: expungePeers.php 97 2005-09-17 01:41:49Z mathias $

// Copyright (c) 2005 Mathias Gug
//
// This program is free software; you can redistribute it and/or 
// modify it under the terms of the GNU General Public License as 
// published by the Free Software Foundation either version 2 of 
// the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, 
// but WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
// See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License 
// along with this program; if not, write to the Free Software Foundation, Inc.
// 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA. 

/**
* Include configuration
*/
require_once 'config.php';

/**
* Include class
*/
require_once 'Log/Log.php';

$log_conf = array('mode' => 0660, 'timeFormat' => '%X %x');
$logger = &Log::singleton('file', '/tmp/expungePeers.php.log', 'expungePeers', $log_conf, $log_level);

/** Log Data **/
function logData($name,$data,$level) {
  global $logger;
  ob_start();
  var_dump($data);
  $rd = ob_get_contents();
  ob_end_clean();
  $logger->log("$name : $rd",$level);
}

/** Fail with an error message **/
function failError($msg) {
	global $Bittorrent_Encode;
	$r = $Bittorrent_Encode->encode(array("failure reason" => $msg));
	sendHttpResponse($r);
	exit();
}


function deletePeerEntry($info_hash,$peer_id,$tuid) {
  global $dbprfx;

  $ih = mysql_real_escape_string($info_hash);
  $pi = mysql_real_escape_string($peer_id);
  # update user stats for the torrent
  $strQuery="UPDATE " . $dbprfx . "members_torrents_stats m, " . $dbprfx . "torrents_peers t SET m.active=0 , m.downloaded = m.downloaded + t.downloaded, m.uploaded = m.uploaded + t.uploaded WHERE m.info_hash='$ih' AND m.tuid='$tuid' AND t.info_hash=m.info_hash AND t.peer_id='$pi' AND t.tuid=m.tuid";
  logData("UPDATE STOPPED Query",$strQuery,PEAR_LOG_DEBUG);
  $rr = mysql_query($strQuery);
  if (!$rr) {
	  logData("ERROR UPDATE STOPPED",mysql_error(),PEAR_LOG_ERR);
  }
  $strQuery="DELETE FROM " . $dbprfx . "torrents_peers WHERE info_hash='$ih' AND peer_id='$pi' AND tuid='$tuid'";
  logData("PEER DELETE Query",$strQuery,PEAR_LOG_DEBUG);
  $rr = mysql_query($strQuery);
  if (!$rr) {
	  logData("ERROR DELETE PEER",mysql_error(),PEAR_LOG_ERR);
  }

}

mysql_connect($dbhost, $dbuser, $dbpass) or failError("Error: connection to mysql failed !");
mysql_select_db($dbname) or failError("Error: connection to database failed !");

$strQuery="SELECT `info_hash`, `peer_id`, `tuid` FROM " . $dbprfx . "torrents_peers WHERE UNIX_TIMESTAMP(last_time) <= UNIX_TIMESTAMP(CURRENT_TIMESTAMP()) - 3*$announce_interval";
logData("SELECT DEAD PEERS Query",$strQuery,PEAR_LOG_DEBUG);
$rr = mysql_query($strQuery);
if (!$rr) {
	logData("ERROR SELECT DEAD PEARS",mysql_error(),PEAR_LOG_ERR);
}
$row = mysql_fetch_row($rr);
while ($row) {
  logData("DEAD PEER",$row,PEAR_LOG_DEBUG);
  deletePeerEntry($row[0],$row[1],$row[2]);
  $row = mysql_fetch_row($rr);
}
?>
